var util = require('util');

var TEMPLATE = 'define(function() {' +
    'return \'%s\'' +
    '});\n';

var escapeContent = function(content) {
  return content.replace(/\\/g, '\\\\').replace(/'/g, '\\\'').replace(/\r?\n/g, '\\n\' +\n    \'');
};

var createHtml2JsRequireJsPreprocessor = function(logger, basePath, config) {
  config = typeof config === 'object' ? config : {};

  var log = logger.create('preprocessor.html2js');
  var stripPrefix = new RegExp('^' + (config.stripPrefix || ''));
  var prependPrefix = config.prependPrefix || '';
  var cacheIdFromPath = config && config.cacheIdFromPath || function(filepath) {
    return prependPrefix + filepath.replace(stripPrefix, '');
  };

  return function(content, file, done) {
    log.debug('Processing "%s".', file.originalPath);

//    var htmlPath = cacheIdFromPath(file.originalPath.replace(basePath + '/', ''));

    file.path = file.path + '.js';

    done(util.format(TEMPLATE, escapeContent(content)));
  };
};

createHtml2JsRequireJsPreprocessor.$inject = ['logger', 'config.basePath', 'config.html2JsRequireJsPreprocessor'];

module.exports = createHtml2JsRequireJsPreprocessor;